﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Data.OleDb;
using C1.Win.C1GanttView;
using C1.GanttView;

namespace GanttView
{
    public partial class Form1 : Form
    {
        OleDbConnection conn;
        OleDbDataAdapter TasksAdapter;
        OleDbDataAdapter ResourcesAdapter;
        OleDbDataAdapter CalendarsAdapter;
        OleDbDataAdapter PropertiesAdapter;

        DataTable table_Tasks = new DataTable();
        DataTable table_Resources = new DataTable();
        DataTable table_Calendars = new DataTable();
        DataTable table_Properties = new DataTable();

        C1.Win.C1GanttView.Resource resource1 = new C1.Win.C1GanttView.Resource();
        C1.Win.C1GanttView.Resource resource2 = new C1.Win.C1GanttView.Resource();
        C1.Win.C1GanttView.Resource resource3 = new C1.Win.C1GanttView.Resource();
        C1.Win.C1GanttView.Resource resource4 = new C1.Win.C1GanttView.Resource();
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

            // Configuring the DataSource
            conn = new OleDbConnection(@"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=..\..\C1NWind_GanttView.mdb");
            CalendarsAdapter = new OleDbDataAdapter("select * from Calendars", conn);
            CalendarsAdapter.Fill(table_Calendars);
            PropertiesAdapter = new OleDbDataAdapter("select * from Properties", conn);
            PropertiesAdapter.Fill(table_Properties);
            ResourcesAdapter = new OleDbDataAdapter("select * from Resources", conn);
            ResourcesAdapter.Fill(table_Resources);
            TasksAdapter = new OleDbDataAdapter("select * from Tasks", conn);
            TasksAdapter.Fill(table_Tasks);                             
         

            //Setting DefaultWorkingTimes
            this.c1GanttView1.DefaultWorkingTimes.Interval_1.Empty = false;
            this.c1GanttView1.DefaultWorkingTimes.Interval_1.From = new System.DateTime(1, 1, 1, 9, 0, 0, 0);
            this.c1GanttView1.DefaultWorkingTimes.Interval_1.To = new System.DateTime(1, 1, 1, 13, 0, 0, 0);
            this.c1GanttView1.DefaultWorkingTimes.Interval_2.Empty = false;
            this.c1GanttView1.DefaultWorkingTimes.Interval_2.From = new System.DateTime(1, 1, 1, 14, 0, 0, 0);
            this.c1GanttView1.DefaultWorkingTimes.Interval_2.To = new System.DateTime(1, 1, 1, 18, 0, 0, 0);

            //Setting Mappings in CalendarStorage
            this.c1GanttView1.DataStorage.CalendarStorage.Mappings.CalendarID.MappingName = "CalendarID";          
            this.c1GanttView1.DataStorage.CalendarStorage.Mappings.Data.MappingName = "Data";          
            this.c1GanttView1.DataStorage.CalendarStorage.Mappings.IdMapping.MappingName = "Id";         
            this.c1GanttView1.DataStorage.CalendarStorage.Mappings.Name.MappingName = "Name";

            //Setting Mappings in PropertyStorage
            this.c1GanttView1.DataStorage.PropertyStorage.Key.MappingName = "Key";           
            this.c1GanttView1.DataStorage.PropertyStorage.Value.MappingName = "Value";

            //Setting Mappings in ResourceStorage
            this.c1GanttView1.DataStorage.ResourceStorage.Mappings.Cost.MappingName = "Cost";        
            this.c1GanttView1.DataStorage.ResourceStorage.Mappings.IdMapping.MappingName = "Id";          
            this.c1GanttView1.DataStorage.ResourceStorage.Mappings.Name.MappingName = "Name";          
            this.c1GanttView1.DataStorage.ResourceStorage.Mappings.Notes.MappingName = "Notes";
            this.c1GanttView1.DataStorage.ResourceStorage.Mappings.ResourceID.MappingName = "ResourceID";          
            this.c1GanttView1.DataStorage.ResourceStorage.Mappings.ResourceType.MappingName = "ResourceType";          
            this.c1GanttView1.DataStorage.ResourceStorage.Mappings.UnitOfMeasure.MappingName = "UnitOfMeasure";
            

            //Setting Mappings in TasksStorage
            this.c1GanttView1.DataStorage.TasksStorage.Mappings.CalendarID.MappingName = "CalendarID";
            this.c1GanttView1.DataStorage.TasksStorage.Mappings.ConstraintDate.MappingName = "ConstraintDate";          
            this.c1GanttView1.DataStorage.TasksStorage.Mappings.ConstraintType.MappingName = "ConstraintType";          
            this.c1GanttView1.DataStorage.TasksStorage.Mappings.CustomFields.MappingName = "CustomFields";          
            this.c1GanttView1.DataStorage.TasksStorage.Mappings.Deadline.MappingName = "Deadline";         
            this.c1GanttView1.DataStorage.TasksStorage.Mappings.Duration.MappingName = "Duration";         
            this.c1GanttView1.DataStorage.TasksStorage.Mappings.DurationUnits.MappingName = "DurationUnits";           
            this.c1GanttView1.DataStorage.TasksStorage.Mappings.Finish.MappingName = "Finish";
            this.c1GanttView1.DataStorage.TasksStorage.Mappings.HideBar.MappingName = "HideBar";           
            this.c1GanttView1.DataStorage.TasksStorage.Mappings.IdMapping.MappingName = "Id";            
            this.c1GanttView1.DataStorage.TasksStorage.Mappings.Initialized.MappingName = "Initialized";          
            this.c1GanttView1.DataStorage.TasksStorage.Mappings.Mode.MappingName = "Mode";           
            this.c1GanttView1.DataStorage.TasksStorage.Mappings.Name.MappingName = "Name";           
            this.c1GanttView1.DataStorage.TasksStorage.Mappings.NextID.MappingName = "NextID";           
            this.c1GanttView1.DataStorage.TasksStorage.Mappings.Notes.MappingName = "Notes";         
            this.c1GanttView1.DataStorage.TasksStorage.Mappings.OutlineParentID.MappingName = "OutlineParentID";          
            this.c1GanttView1.DataStorage.TasksStorage.Mappings.PercentComplete.MappingName = "PercentComplete";          
            this.c1GanttView1.DataStorage.TasksStorage.Mappings.Predecessors.MappingName = "Predecessors";          
            this.c1GanttView1.DataStorage.TasksStorage.Mappings.Resources.MappingName = "Resources";           
            this.c1GanttView1.DataStorage.TasksStorage.Mappings.Start.MappingName = "Start";           
            this.c1GanttView1.DataStorage.TasksStorage.Mappings.Summary.MappingName = "Summary";            
            this.c1GanttView1.DataStorage.TasksStorage.Mappings.TaskID.MappingName = "TaskID";

            //Setting the TimeScale
            this.c1GanttView1.Timescale.BottomTier.Align = C1.Win.C1GanttView.ScaleLabelAlignment.Center;
            this.c1GanttView1.Timescale.BottomTier.Format = "w";
            this.c1GanttView1.Timescale.BottomTier.Visible = true;
            this.c1GanttView1.Timescale.BottomTier.UseFiscalYear = true;
            this.c1GanttView1.Timescale.BottomTier.Units = TimescaleUnits.Days;
            this.c1GanttView1.Timescale.BottomTier.Count = 1;

            this.c1GanttView1.Timescale.MiddleTier.Format = "nnnn d";
            this.c1GanttView1.Timescale.MiddleTier.Units = C1.Win.C1GanttView.TimescaleUnits.Weeks;
            this.c1GanttView1.Timescale.MiddleTier.Visible = true;
            this.c1GanttView1.Timescale.MiddleTier.Count = 1;

            
            //Binding C1GanttView to the DataSource
            c1GanttView1.DataStorage.CalendarStorage.DataSource = table_Calendars;
            c1GanttView1.DataStorage.PropertyStorage.DataSource = table_Properties;
            c1GanttView1.DataStorage.ResourceStorage.DataSource = table_Resources;
            c1GanttView1.DataStorage.TasksStorage.DataSource = table_Tasks;

            //Setting the Columns to be displayed in C1GanttView
            C1.Win.C1GanttView.TaskPropertyColumn taskPropertyColumn1 = new C1.Win.C1GanttView.TaskPropertyColumn();
            C1.Win.C1GanttView.TaskPropertyColumn taskPropertyColumn2 = new C1.Win.C1GanttView.TaskPropertyColumn();
            C1.Win.C1GanttView.TaskPropertyColumn taskPropertyColumn3 = new C1.Win.C1GanttView.TaskPropertyColumn();
            C1.Win.C1GanttView.TaskPropertyColumn taskPropertyColumn4 = new C1.Win.C1GanttView.TaskPropertyColumn();
            C1.Win.C1GanttView.TaskPropertyColumn taskPropertyColumn5 = new C1.Win.C1GanttView.TaskPropertyColumn();
            C1.Win.C1GanttView.TaskPropertyColumn taskPropertyColumn6 = new C1.Win.C1GanttView.TaskPropertyColumn();
            C1.Win.C1GanttView.TaskPropertyColumn taskPropertyColumn7 = new C1.Win.C1GanttView.TaskPropertyColumn();
            C1.Win.C1GanttView.TaskPropertyColumn taskPropertyColumn8 = new C1.Win.C1GanttView.TaskPropertyColumn();
            C1.Win.C1GanttView.TaskPropertyColumn taskPropertyColumn9 = new C1.Win.C1GanttView.TaskPropertyColumn();
            C1.Win.C1GanttView.TaskPropertyColumn taskPropertyColumn10 = new C1.Win.C1GanttView.TaskPropertyColumn();
            C1.Win.C1GanttView.TaskPropertyColumn taskPropertyColumn11 = new C1.Win.C1GanttView.TaskPropertyColumn();
            C1.Win.C1GanttView.TaskPropertyColumn taskPropertyColumn12 = new C1.Win.C1GanttView.TaskPropertyColumn();
            C1.Win.C1GanttView.TaskPropertyColumn taskPropertyColumn13 = new C1.Win.C1GanttView.TaskPropertyColumn();
            C1.Win.C1GanttView.TaskPropertyColumn taskPropertyColumn14 = new C1.Win.C1GanttView.TaskPropertyColumn();
            
            
            taskPropertyColumn1.Property = C1.Win.C1GanttView.TaskProperty.Mode;           
            taskPropertyColumn2.Property = C1.Win.C1GanttView.TaskProperty.Name;           
            taskPropertyColumn3.Property = C1.Win.C1GanttView.TaskProperty.Duration;
            taskPropertyColumn3.TextAlign = System.Windows.Forms.HorizontalAlignment.Left;          
            taskPropertyColumn4.Property = C1.Win.C1GanttView.TaskProperty.DurationUnits;           
            taskPropertyColumn5.Property = C1.Win.C1GanttView.TaskProperty.Start;          
            taskPropertyColumn6.Property = C1.Win.C1GanttView.TaskProperty.Finish;        
            taskPropertyColumn7.Property = C1.Win.C1GanttView.TaskProperty.PercentComplete;
            taskPropertyColumn7.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;         
            taskPropertyColumn8.Property = C1.Win.C1GanttView.TaskProperty.ConstraintType;        
            taskPropertyColumn9.Property = C1.Win.C1GanttView.TaskProperty.ConstraintDate;        
            taskPropertyColumn10.Property = C1.Win.C1GanttView.TaskProperty.Predecessors;        
            taskPropertyColumn11.Property = C1.Win.C1GanttView.TaskProperty.Deadline;           
            taskPropertyColumn12.Property = C1.Win.C1GanttView.TaskProperty.Calendar;         
            taskPropertyColumn13.Property = C1.Win.C1GanttView.TaskProperty.ResourceNames;         
            taskPropertyColumn14.Property = C1.Win.C1GanttView.TaskProperty.Notes;

            this.c1GanttView1.Columns.Add(taskPropertyColumn1);
            this.c1GanttView1.Columns.Add(taskPropertyColumn2);
            this.c1GanttView1.Columns.Add(taskPropertyColumn3);
            this.c1GanttView1.Columns.Add(taskPropertyColumn4);
            this.c1GanttView1.Columns.Add(taskPropertyColumn5);
            this.c1GanttView1.Columns.Add(taskPropertyColumn6);
            this.c1GanttView1.Columns.Add(taskPropertyColumn7);
            this.c1GanttView1.Columns.Add(taskPropertyColumn8);
            this.c1GanttView1.Columns.Add(taskPropertyColumn9);
            this.c1GanttView1.Columns.Add(taskPropertyColumn10);
            this.c1GanttView1.Columns.Add(taskPropertyColumn11);
            this.c1GanttView1.Columns.Add(taskPropertyColumn12);
            this.c1GanttView1.Columns.Add(taskPropertyColumn13);
            this.c1GanttView1.Columns.Add(taskPropertyColumn14);          

           
        }

     
    }
}
